## mudlet 3.0.0~rc7iota

=== CMakeLists.txt ===
############################################################################
#    Copyright (C) 2014 by Ahmed Charles - acharles@outlook.com            #
#    Copyright (C) 2015-2016 by Stephen Lyons - slysven@virginmedia.com    #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

PROJECT(mudlet)

# Windows builds need 2.8.11, but for other platforms 2.8.9 should be enough
IF(MSVC)
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
ELSE()
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.9)
ENDIF()

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

IF(WIN32)
    SET(APP_TARGET mudlet.exe)
ELSEIF(APPLE)
    SET(APP_TARGET Mudlet)
ELSE()
    SET(APP_TARGET mudlet)
ENDIF()

SET(APP_VERSION 3.0.0)
SET(APP_BUILD "-iota")
# APP_BUILD should only be empty/null in official "release" builds,
# developers may like to set it to their user and branch names to make it easier
# to tell different builds apart!
#
# Changing the above pair of values affects: ctelnet.cpp, main.cpp, mudlet.cpp
# dlgAboutDialog.cpp and TLuaInterpreter.cpp.  It will not necessarily cause
# those files to be automatically rebuilt so you may need to 'touch' those files if
# the variables are changed and you are not doing a full, clean, rebuild!
# Use APP_VERSION, APP_BUILD and APP_TARGET defines in the source code if needed.
# IMPORTANT:
# To insure consistency please ensure the SAME of the first two values are also
# assigned to the "VERSION" and "BUILD" variables in the native qmake project file,
# i.e. ./src/src.pro

ADD_SUBDIRECTORY(src)

=== src/CMakeLists.txt ===
############################################################################
#    Copyright (C) 2014 by Ahmed Charles - acharles@outlook.com            #
#    Copyright (C) 2015 by Stephen Lyons - slysven@virginmedia.com         #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../cmake ${CMAKE_MODULE_PATH})

SET(mudlet_RCCS mudlet_alpha.qrc)

SET(mudlet_SRCS
    ActionUnit.cpp
    AliasUnit.cpp
    ctelnet.cpp
    dlgAboutDialog.cpp
    dlgActionMainArea.cpp
    dlgAliasMainArea.cpp
    dlgColorTrigger.cpp
    dlgComposer.cpp
    dlgConnectionProfiles.cpp
    dlgIRC.cpp
    dlgKeysMainArea.cpp
    dlgMapper.cpp
    dlgNotepad.cpp
    dlgOptionsAreaAction.cpp
    dlgOptionsAreaAlias.cpp
    dlgOptionsAreaScripts.cpp
    dlgOptionsAreaTimers.cpp
    dlgOptionsAreaTriggers.cpp
    dlgPackageExporter.cpp
    dlgProfilePreferences.cpp
    dlgRoomExits.cpp
    dlgScriptsMainArea.cpp
    dlgSearchArea.cpp
    dlgSourceEditorArea.cpp
    dlgSystemMessageArea.cpp
    dlgTimersMainArea.cpp
    dlgTriggerEditor.cpp
    dlgTriggerPatternEdit.cpp
    dlgTriggersMainArea.cpp
    dlgVarsMainArea.cpp
    EAction.cpp
    exitstreewidget.cpp
    FontManager.cpp
    glwidget.cpp
    Host.cpp
    HostManager.cpp
    HostPool.cpp
    KeyUnit.cpp
    LuaInterface.cpp
    main.cpp
    mudlet.cpp
    ScriptUnit.cpp
    T2DMap.cpp
    TAction.cpp
    TAlias.cpp
    TArea.cpp
    TBuffer.cpp
    TCommandLine.cpp
    TConsole.cpp
    TDebug.cpp
    TEasyButtonBar.cpp
    TFlipButton.cpp
    TForkedProcess.cpp
    THighlighter.cpp
    TimerUnit.cpp
    TKey.cpp
    TLabel.cpp
    TLuaInterpreter.cpp
    TMap.cpp
    TriggerUnit.cpp
    TRoom.cpp
    TRoomDB.cpp
    TScript.cpp
    TSplitter.cpp
    TSplitterHandle.cpp
    TTextEdit.cpp
    TTimer.cpp
    TToolBar.cpp
    TTreeWidget.cpp
    TTrigger.cpp
    TVar.cpp
    VarUnit.cpp
    XMLexport.cpp
    XMLimport.cpp
)

# This is for compiled UI files, not those used at runtime though the resource file.
SET(mudlet_UIS
    ui/about_dialog.ui
    ui/actions_main_area.ui
    ui/aliases_main_area.ui
    ui/color_trigger.ui
    ui/composer.ui
    ui/connection_profiles.ui
    ui/dlgPackageExporter.ui
    ui/extended_search_area.ui
    ui/irc.ui
    ui/keybindings_main_area.ui
    ui/main_window.ui
    ui/mapper.ui
    ui/notes_editor.ui
    ui/options_area_actions.ui
    ui/options_area_aliases.ui
    ui/options_area_scripts.ui
    ui/options_area_timers.ui
    ui/options_area_triggers.ui
    ui/profile_preferences.ui
    ui/room_exits.ui
    ui/scripts_main_area.ui
    ui/source_editor_area.ui
    ui/system_message_area.ui
    ui/timers_main_area.ui
    ui/triggers_main_area.ui
    ui/trigger_editor.ui
    ui/trigger_pattern_edit.ui
    ui/vars_main_area.ui
)

SET(mudlet_MOC_HDRS 
    ctelnet.h
    dlgAboutDialog.h
    dlgActionMainArea.h
    dlgAliasMainArea.h
    dlgColorTrigger.h
    dlgComposer.h
    dlgConnectionProfiles.h
    dlgIRC.h
    dlgKeysMainArea.h
    dlgMapper.h
    dlgNotepad.h
    dlgOptionsAreaAction.h
    dlgOptionsAreaAlias.h
    dlgOptionsAreaScripts.h
    dlgOptionsAreaTimers.h
    dlgOptionsAreaTriggers.h
    dlgPackageExporter.h
    dlgProfilePreferences.h
    dlgRoomExits.h
    dlgScriptsMainArea.h
    dlgSearchArea.h
    dlgSourceEditorArea.h
    dlgSystemMessageArea.h
    dlgTimersMainArea.h
    dlgTriggerEditor.h
    dlgTriggerPatternEdit.h
    dlgTriggersMainArea.h
    dlgVarsMainArea.h
    EAction.h
    exitstreewidget.h
    glwidget.h
    mudlet.h
    T2DMap.h
    TCommandLine.h
    TConsole.h
    TEasyButtonBar.h
    TForkedProcess.h
    THighlighter.h
    TLabel.h
    TLuaInterpreter.h
    TMap.h
    TSplitter.h
    TTextEdit.h
    TToolBar.h
    TTreeWidget.h
)

SET(mudlet_HDRS
    ActionUnit.h
    AliasUnit.h
    FontManager.h
    Host.h
    HostManager.h
    HostPool.h
    KeyUnit.h
    LuaInterface.h
    pre_guard.h
    post_guard.h
    ScriptUnit.h
    TAction.h
    TAlias.h
    TArea.h
    TAstar.h
    TBuffer.h
    TDebug.h
    TEvent.h
    TFlipButton.h
    TimerUnit.h
    TKey.h
    TMatchState.h
    Tree.h
    TriggerUnit.h
    TRoom.h
    TRoomDB.h
    TScript.h
    TSplitterHandle.h
    TTimer.h
    TTrigger.h
    TVar.h
    VarUnit.h
    XMLexport.h
    XMLimport.h
)

IF(MSVC)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -MP") # parallel builds
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4305") # '=' : truncation from 'double' to 'float'
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4309") # 'initializing' : truncation of constant value
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4996") # deprecation
ELSE(MSVC)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
ENDIF(MSVC)

SET(PCRE_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "PCRE install directory.")

SET(YAJL_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "YAJL install directory.")

SET(HUNSPELL_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "HUNSPELL install directory.")

SET(ZIP_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "ZIP install directory.")

IF(EXISTS "${PROJECT_SOURCE_DIR}/../include/lua.h")
  SET(LUA_INCLUDE_DIR_TEMP "${PROJECT_SOURCE_DIR}/../include")
  GET_FILENAME_COMPONENT(LUA_INCLUDE_DIR ${LUA_INCLUDE_DIR_TEMP} ABSOLUTE CACHE)
  IF(EXISTS "${PROJECT_SOURCE_DIR}/../lib/lualib.lib")
    SET(LUA_LIBRARY_RELEASE_TEMP "${PROJECT_SOURCE_DIR}/../lib/lualib.lib")
    GET_FILENAME_COMPONENT(LUA_LIBRARY_RELEASE ${LUA_LIBRARY_RELEASE_TEMP} ABSOLUTE CACHE)
  ENDIF()
  IF(EXISTS "${PROJECT_SOURCE_DIR}/../lib/lualibd.lib")
    SET(LUA_LIBRARY_DEBUG_TEMP "${PROJECT_SOURCE_DIR}/../lib/lualibd.lib")
    GET_FILENAME_COMPONENT(LUA_LIBRARY_DEBUG ${LUA_LIBRARY_DEBUG_TEMP} ABSOLUTE CACHE)
  ENDIF()
  IF(LUA_LIBRARY_DEBUG AND LUA_LIBRARY_RELEASE)
    SET(LUA_LIBRARY optimized ${LUA_LIBRARY_RELEASE} debug ${LUA_LIBRARY_DEBUG} )
  ELSEIF(LUA_LIBRARY_RELEASE)
    SET(LUA_LIBRARY ${LUA_LIBRARY_RELEASE} )
  ELSEIF(LUA_LIBRARY_DEBUG)
    SET(LUA_LIBRARY ${LUA_LIBRARY_DEBUG} )
  ENDIF()
ENDIF()

IF(WIN32)
  IF(EXISTS "${PROJECT_SOURCE_DIR}/../include/zlib.h")
    SET(ZLIB_INCLUDE_DIR_TEMP "${PROJECT_SOURCE_DIR}/../include")
    GET_FILENAME_COMPONENT(ZLIB_INCLUDE_DIR ${ZLIB_INCLUDE_DIR_TEMP} ABSOLUTE CACHE)
    SET(ZLIB_ROOT "${PROJECT_SOURCE_DIR}/..")
    IF(EXISTS "${PROJECT_SOURCE_DIR}/../lib/zlibstat.lib")
      SET(ZLIB_LIBRARY_RELEASE_TEMP "${PROJECT_SOURCE_DIR}/../lib/zlibstat.lib")
      GET_FILENAME_COMPONENT(ZLIB_LIBRARY_RELEASE ${ZLIB_LIBRARY_RELEASE_TEMP} ABSOLUTE CACHE)
    ENDIF()
    IF(EXISTS "${PROJECT_SOURCE_DIR}/../lib/zlibstatd.lib")
      SET(ZLIB_LIBRARY_DEBUG_TEMP "${PROJECT_SOURCE_DIR}/../lib/zlibstatd.lib")
      GET_FILENAME_COMPONENT(ZLIB_LIBRARY_DEBUG ${ZLIB_LIBRARY_DEBUG_TEMP} ABSOLUTE CACHE)
    ENDIF()
    IF(ZLIB_LIBRARY_DEBUG AND ZLIB_LIBRARY_RELEASE)
      SET(ZLIB_LIBRARY optimized ${ZLIB_LIBRARY_RELEASE} debug ${ZLIB_LIBRARY_DEBUG} )
    ELSEIF(ZLIB_LIBRARY_RELEASE)
      SET(ZLIB_LIBRARY ${ZLIB_LIBRARY_RELEASE} )
    ELSEIF(ZLIB_LIBRARY_DEBUG)
      SET(ZLIB_LIBRARY ${ZLIB_LIBRARY_DEBUG} )
    ENDIF()
  ENDIF()
ENDIF()

# Break each step into a separate command so any status message is output straigh away
IF(APPLE)
  # The include directory setup for Zip is unusual in that as well as e.g. /usr/include/zip.h
  # we need the path to an interal header zipconf.g that it calls for using '<''>'s
  # i.e. SYSTEM #include delimiters which are typically located at e.g. /usr/lib/libzip/include/zipconf.h
  # and using pkg-config is the recommended way to get the details.
  # Spotted recommendation to use pkg-config here https://github.com/Homebrew/homebrew/issues/13390
  FIND_PACKAGE(PkgConfig)
  IF(NOT(PKG_CONFIG_FOUND))
    MESSAGE(WARNING "Unable to use pkg_config - will possibly fail to find/use Zip library...")
  ENDIF()
ENDIF()

IF((APPLE) AND (PKG_CONFIG_FOUND))
  PKG_SEARCH_MODULE(PC_ZIP zip libzip)
  # Use a PC_ prefix to distinguish between what pkg-config finds and a direct use of FIND_PACKAGE(ZIP)
  # Package "zip" is called "libzip" at least on MY Linux box so look for BOTH
  IF(PC_ZIP_FOUND)
    IF(PC_ZIP_zip_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"zip\" version: ${PC_ZIP_zip_VERSION} with:")
    ELSEIF(PC_ZIP_libzip_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"libzip\" version: ${PC_ZIP_libzip_VERSION} with:")
    ELSE()
      MESSAGE(STATUS "Using pkg_config, found Zip version: ${PC_ZIP_VERSION} with:")
    ENDIF()
    MESSAGE(STATUS "  include directory(ies), ZIP_INCLUDE_DIRS: ${PC_ZIP_INCLUDE_DIRS} .")
    MESSAGE(STATUS "  library(ies): ZIP_LIBRARY_DIRS: ${PC_ZIP_LIBRARY_DIRS}; ZIP_LIBDIR: ${PC_ZIP_LIBDIR}. ")
  ELSE()
    MESSAGE(WARNING "Using pkg_config, failed to find any version of Zip library!")
  ENDIF()
ENDIF()

IF((APPLE) AND (PKG_CONFIG_FOUND))
  # Examining Homebrew (for MacOs) for libzzip:
  # https://bintray.com/homebrew/bottles/libzzip found that they use pkg-config
  # So use that to try and find what we want
  PKG_SEARCH_MODULE(PC_ZZIPLIB zziplib libzzip zzip)
  IF(PC_ZZIPLIB_FOUND)
    IF(PC_ZZIPLIB_zziplib_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"zziplib\" version: ${PC_ZZIPLIB_zziplib_VERSION} with:")
    ELSEIF(PC_ZZIPLIB_libzzip_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"libzzip\" version: ${PC_ZZIPLIB_libzzip_VERSION} with:")
    ELSEIF(PC_ZZIPLIB_zzip_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"zzip\" version: ${PC_ZZIPLIB_zzip_VERSION} with:")
    ELSE()
      MESSAGE(STATUS "Using pkg_config, found Zzip version: ${PC_ZZIPLIB_VERSION} with:")
    ENDIF()
    MESSAGE(STATUS "  include directory(ies), ZZIPLIB_INCLUDE_DIRS: ${PC_ZZIPLIB_INCLUDE_DIRS} .")
    MESSAGE(STATUS "  library(ies): ZZIPLIB_LIBRARY_DIRS: ${PC_ZZIPLIB_LIBRARY_DIRS}; ZZIPLIB_LIBDIR: ${PC_ZZIPLIB_LIBDIR}. ")
  ELSEIF()
    MESSAGE(WARNING "Using pkg_config, failed to find any version of Zziplib library!")
  ENDIF()
ENDIF()

IF((APPLE) AND (PKG_CONFIG_FOUND))
  PKG_SEARCH_MODULE(PC_HUNSPELL hunspell libhunspell)
  IF(PC_HUNSPELL_FOUND)
    IF(PC_HUNSPELL_hunspell_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"hunspell\" version: ${PC_HUNSPELL_hunspell_VERSION} with:")
    ELSEIF(PC_HUNSPELL_libhunspell_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"libhunspell\" version: ${PC_HUNSPELL_libhunspell_VERSION} with:")
    ELSE()
      MESSAGE(STATUS "Using pkg_config, found Hunspell version: ${PC_HUNSPELL_VERSION} with:")
    ENDIF()
    MESSAGE(STATUS "  include directory(ies), HUNSPELL_INCLUDE_DIRS: ${PC_HUNSPELL_INCLUDE_DIRS} .")
    MESSAGE(STATUS "  library(ies): HUNSPELL_LIBRARY_DIRS: ${PC_HUNSPELL_LIBRARY_DIRS}; HUNSPELL_LIBRARY_DIR: ${PC_HUNSPELL_LIBRARY_DIR}. ")
  ELSEIF()
    MESSAGE(WARNING "Using pkg_config, failed to find any version of Hunspell library!")
  ENDIF()
ENDIF()

=== src/irc/CMakeLists.txt ===
############################################################################
# LibIrcClient-Qt                                                          #
#                                                                          #
#    Copyright (C) 2014 by Ahmed Charles - acharles@outlook.com            #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

IF(MSVC)
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
ELSE()
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.9)
ENDIF()

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

PROJECT(ircclient-qt)

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5Network REQUIRED)

SET (SRCS src/irc.cpp src/ircbuffer.cpp src/ircsession.cpp src/ircutil.cpp)
SET (HDRS include/ircbuffer_p.h include/ircsession_p.h)
SET (MOC_HDRS include/irc.h include/ircbuffer.h include/ircsession.h)
SET (PUB_HDRS ${MOC_HDRS} include/ircglobal.h include/ircutil.h include/Irc include/IrcBuffer include/IrcGlobal include/IrcSession include/IrcUtil)

QT5_GENERATE_MOC(include/ircbuffer.h ${CMAKE_CURRENT_BINARY_DIR}/moc_ircbuffer.cpp)
QT5_GENERATE_MOC(include/ircsession.h ${CMAKE_CURRENT_BINARY_DIR}/moc_ircsession.cpp)

SET_PROPERTY(SOURCE src/ircbuffer.cpp APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/moc_ircbuffer.cpp)
SET_PROPERTY(SOURCE src/ircsession.cpp APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/moc_ircsession.cpp)

ADD_LIBRARY(irccqt STATIC ${SRCS} ${HDRS} ${PUB_HDRS})
TARGET_LINK_LIBRARIES(irccqt ${Qt5Core_LIBRARIES} ${Qt5Network_LIBRARIES})

INCLUDE_DIRECTORIES(${Qt5Core_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/include)

=== debian/changelog ===
mudlet (1:3.0.0~rc7iota-1) unstable; urgency=medium

  * New upstream release

 -- Craig Small <csmall@debian.org>  Tue, 22 Nov 2016 22:12:53 +1100

=== debian/control ===
Source: mudlet
Section: games
Priority: extra
Maintainer: Craig Small <csmall@debian.org>
Build-Depends: debhelper (>= 9), pkg-config,
               libpcre3-dev, zlib1g-dev, libboost-dev, libyajl-dev,
               libhunspell-dev,
               qtbase5-dev, qt5-qmake, qttools5-dev, qtmultimedia5-dev,
               libqt5opengl5-dev,
               liblua5.1-dev, libzip-dev
Standards-Version: 3.9.8
Vcs-Git: git://anonscm.debian.org/collab-maint/mudlet.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mudlet.git
Homepage: http://www.mudlet.org/

Package: mudlet
Architecture: alpha amd64 arm64 hppa i386 ia64 m32r m68k mips mipsel powerpc ppc64 ppc64el s390 s390x sh3 sh3eb sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, lua5.1-rex-pcre, lua5.1-sql-sqlite3
Suggests: hunspell-en-us
Description: Graphical MUD client with fast lua scripting support
 A completely redesigned MUD (Multi User Dungeon) client that is easy to
 use and customise.  Both power users and plain gamers alike will feel at
 home with Mudlet, without having to waste too much timer figuring out
 how to do something.
 . 
 Mudlet is designed to be very fast and efficient right from the start.
 Its scripting engine is designed to handle thousands of lines under
 one second. The scripting framework uses Lua - a small, fast and
 efficient scripting language.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export QT_SELECT=5

PACKAGE=mudlet
SRC_VERSION:=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')
TARBALL=$(PACKAGE)_$(SRC_VERSION).orig.tar.gz

%:
	dh $@ 

override_dh_auto_clean:
	[ ! -f src/Makefile ] || $(MAKE) -C src distclean

override_dh_auto_configure:
	cd src && qmake \
		QMAKE_CFLAGS_RELEASE="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CFLAGS_DEBUG="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CXXFLAGS_RELEASE="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CXXFLAGS_DEBUG="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_LFLAGS_RELEASE="$(shell dpkg-buildflags --get LDFLAGS)"  \
		QMAKE_LFLAGS_DEBUG="$(shell dpkg-buildflags --get LDFLAGS)" 

override_dh_auto_build:
	make -C src

override_dh_install:
	dh_install
	chmod a-x debian/mudlet/usr/share/games/mudlet/lua/*.lua
	chmod a-x debian/mudlet/usr/share/games/mudlet/lua/geyser/*.lua

get-orig-source:
	rm -rf get-orig-source $(TARBALL)
	mkdir -p get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig
	wget -O get-orig-source/upstream.tgz "http://mudlet.git.sourceforge.net/git/gitweb.cgi?p=mudlet/mudlet;a=snapshot;h=HEAD;sf=tgz"
	cd get-orig-source && tar xfz upstream.tgz -C $(PACKAGE)-$(SRC_VERSION).orig --strip-components=1
	cd get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig/src && \
		rm -rf yajl fonts hunspell en_US.aff en_US.dic
	tar cvfz $(TARBALL) -C get-orig-source $(PACKAGE)-$(SRC_VERSION).orig
	rm -rf get-orig-source

## mudlet 3.0.1

=== debian/changelog ===
mudlet (1:3.0.1-1) unstable; urgency=medium

  * New upstream release
  * Added lua zip and filesystem dependencies

 -- Craig Small <csmall@debian.org>  Fri, 14 Apr 2017 07:14:11 +1000

mudlet (1:3.0.0-2) unstable; urgency=medium

  * Remove upstream Makefile Closes: #858730

 -- Craig Small <csmall@debian.org>  Sun, 26 Mar 2017 08:15:59 +1100

mudlet (1:3.0.0-1) unstable; urgency=medium

  * Upstream 3.0.0 finally released!

 -- Craig Small <csmall@debian.org>  Sat, 25 Mar 2017 13:20:13 +1100

## mudlet 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,34 +18,39 @@
 #    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
 ############################################################################
 
+# Should be called before PROJECT.
+CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
+
 PROJECT(mudlet)
 
-# Windows builds need 2.8.11, but for other platforms 2.8.9 should be enough
-IF(MSVC)
-  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
+IF(CMAKE_CONFIGURATION_TYPES)
+  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND}
+                    --force-new-ctest-process --output-on-failure
+                    --build-config "$<CONFIGURATION>")
 ELSE()
-  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.9)
+  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND}
+                    --force-new-ctest-process --output-on-failure)
 ENDIF()
+
+ENABLE_TESTING()
 
 IF(POLICY CMP0020)
   CMAKE_POLICY(SET CMP0020 NEW)
 ENDIF()
 
 IF(WIN32)
-    SET(APP_TARGET mudlet.exe)
+  SET(APP_TARGET mudlet.exe)
 ELSEIF(APPLE)
-    SET(APP_TARGET Mudlet)
+  SET(APP_TARGET Mudlet)
 ELSE()
-    SET(APP_TARGET mudlet)
+  SET(APP_TARGET mudlet)
 ENDIF()
 
-SET(APP_VERSION 3.0.0)
-SET(APP_BUILD "-iota")
 # APP_BUILD should only be empty/null in official "release" builds,
-# developers may like to set it to their user and branch names to make it easier
-# to tell different builds apart!
+# developers may like to set the MUDLET_VERSION_BUILD environment variable to
+# their user and branch names to make it easier to tell different builds apart!
 #
-# Changing the above pair of values affects: ctelnet.cpp, main.cpp, mudlet.cpp
+# Changing this pair of values affects: ctelnet.cpp, main.cpp, mudlet.cpp
 # dlgAboutDialog.cpp and TLuaInterpreter.cpp.  It will not necessarily cause
 # those files to be automatically rebuilt so you may need to 'touch' those files if
 # the variables are changed and you are not doing a full, clean, rebuild!
@@ -54,5 +59,20 @@
 # To insure consistency please ensure the SAME of the first two values are also
 # assigned to the "VERSION" and "BUILD" variables in the native qmake project file,
 # i.e. ./src/src.pro
+SET(APP_VERSION 3.2.0)
+IF(DEFINED ENV{MUDLET_VERSION_BUILD} AND NOT $ENV{MUDLET_VERSION_BUILD} STREQUAL "")
+  SET(APP_BUILD $ENV{MUDLET_VERSION_BUILD})
+else()
+  SET(APP_BUILD "")
+ENDIF()
+
+SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
+
+ADD_SUBDIRECTORY(3rdparty/communi)
+ADD_SUBDIRECTORY(3rdparty/lua_yajl)
+# Needed (just) on MacOs as an #include in luazip.h:
+IF(APPLE)
+  ADD_SUBDIRECTORY(3rdparty/luazip)
+ENDIF()
 
 ADD_SUBDIRECTORY(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
-#    Copyright (C) 2014 by Ahmed Charles - acharles@outlook.com            #
-#    Copyright (C) 2015 by Stephen Lyons - slysven@virginmedia.com         #
+#    Copyright (C) 2014-2017 by Ahmed Charles - acharles@outlook.com       #
+#    Copyright (C) 2015-2016 by Stephen Lyons - slysven@virginmedia.com    #
 #                                                                          #
 #    This program is free software; you can redistribute it and/or modify  #
 #    it under the terms of the GNU General Public License as published by  #
@@ -18,8 +18,6 @@
 #    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
 ############################################################################
 
-SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../cmake ${CMAKE_MODULE_PATH})
-
 SET(mudlet_RCCS mudlet_alpha.qrc)
 
 SET(mudlet_SRCS
@@ -36,16 +34,10 @@
     dlgKeysMainArea.cpp
     dlgMapper.cpp
     dlgNotepad.cpp
-    dlgOptionsAreaAction.cpp
-    dlgOptionsAreaAlias.cpp
-    dlgOptionsAreaScripts.cpp
-    dlgOptionsAreaTimers.cpp
-    dlgOptionsAreaTriggers.cpp
     dlgPackageExporter.cpp
     dlgProfilePreferences.cpp
     dlgRoomExits.cpp
     dlgScriptsMainArea.cpp
-    dlgSearchArea.cpp
     dlgSourceEditorArea.cpp
     dlgSystemMessageArea.cpp
     dlgTimersMainArea.cpp
@@ -59,7 +51,6 @@
     glwidget.cpp
     Host.cpp
     HostManager.cpp
-    HostPool.cpp
     KeyUnit.cpp
     LuaInterface.cpp
     main.cpp
@@ -73,6 +64,7 @@
     TCommandLine.cpp
     TConsole.cpp
     TDebug.cpp
+    TDockWidget.cpp
     TEasyButtonBar.cpp
     TFlipButton.cpp
     TForkedProcess.cpp
@@ -108,17 +100,11 @@
     ui/composer.ui
     ui/connection_profiles.ui
     ui/dlgPackageExporter.ui
-    ui/extended_search_area.ui
     ui/irc.ui
     ui/keybindings_main_area.ui
     ui/main_window.ui
     ui/mapper.ui
     ui/notes_editor.ui
-    ui/options_area_actions.ui
-    ui/options_area_aliases.ui
-    ui/options_area_scripts.ui
-    ui/options_area_timers.ui
-    ui/options_area_triggers.ui
     ui/profile_preferences.ui
     ui/room_exits.ui
     ui/scripts_main_area.ui
@@ -143,16 +129,10 @@
     dlgKeysMainArea.h
     dlgMapper.h
     dlgNotepad.h
-    dlgOptionsAreaAction.h
-    dlgOptionsAreaAlias.h
-    dlgOptionsAreaScripts.h
-    dlgOptionsAreaTimers.h
-    dlgOptionsAreaTriggers.h
     dlgPackageExporter.h
     dlgProfilePreferences.h
     dlgRoomExits.h
     dlgScriptsMainArea.h
-    dlgSearchArea.h
     dlgSourceEditorArea.h
     dlgSystemMessageArea.h
     dlgTimersMainArea.h
@@ -174,6 +154,7 @@
     TLuaInterpreter.h
     TMap.h
     TSplitter.h
+    TSplitterHandle.h
     TTextEdit.h
     TToolBar.h
     TTreeWidget.h
@@ -185,7 +166,6 @@
     FontManager.h
     Host.h
     HostManager.h
-    HostPool.h
     KeyUnit.h
     LuaInterface.h
     pre_guard.h
@@ -197,6 +177,8 @@
     TAstar.h
     TBuffer.h
     TDebug.h
+    TDockWidget.h
+    testdbg.h
     TEvent.h
     TFlipButton.h
     TimerUnit.h
@@ -218,13 +200,23 @@
 
 IF(MSVC)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -MP") # parallel builds
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Zc:inline") # improve link times
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Zc:rvalueCast") # improve conformance
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4305") # '=' : truncation from 'double' to 'float'
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4309") # 'initializing' : truncation of constant value
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4996") # deprecation
-ELSE(MSVC)
+ELSE()
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
-ENDIF(MSVC)
+  IF(APPLE)
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
+    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
+  ENDIF()
+ENDIF()
+
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 SET(PCRE_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "PCRE install directory.")
 
@@ -277,7 +269,7 @@
   ENDIF()
 ENDIF()
 
-# Break each step into a separate command so any status message is output straigh away
+# Break each step into a separate command so any status message is output straight away
 IF(APPLE)
   # The include directory setup for Zip is unusual in that as well as e.g. /usr/include/zip.h
   # we need the path to an interal header zipconf.g that it calls for using '<''>'s
@@ -310,28 +302,6 @@
 ENDIF()
 
 IF((APPLE) AND (PKG_CONFIG_FOUND))
-  # Examining Homebrew (for MacOs) for libzzip:
-  # https://bintray.com/homebrew/bottles/libzzip found that they use pkg-config
-  # So use that to try and find what we want
-  PKG_SEARCH_MODULE(PC_ZZIPLIB zziplib libzzip zzip)
-  IF(PC_ZZIPLIB_FOUND)
-    IF(PC_ZZIPLIB_zziplib_FOUND)
-      MESSAGE(STATUS "Using pkg_config, found \"zziplib\" version: ${PC_ZZIPLIB_zziplib_VERSION} with:")
-    ELSEIF(PC_ZZIPLIB_libzzip_FOUND)
-      MESSAGE(STATUS "Using pkg_config, found \"libzzip\" version: ${PC_ZZIPLIB_libzzip_VERSION} with:")
-    ELSEIF(PC_ZZIPLIB_zzip_FOUND)
-      MESSAGE(STATUS "Using pkg_config, found \"zzip\" version: ${PC_ZZIPLIB_zzip_VERSION} with:")
-    ELSE()
-      MESSAGE(STATUS "Using pkg_config, found Zzip version: ${PC_ZZIPLIB_VERSION} with:")
-    ENDIF()
-    MESSAGE(STATUS "  include directory(ies), ZZIPLIB_INCLUDE_DIRS: ${PC_ZZIPLIB_INCLUDE_DIRS} .")
-    MESSAGE(STATUS "  library(ies): ZZIPLIB_LIBRARY_DIRS: ${PC_ZZIPLIB_LIBRARY_DIRS}; ZZIPLIB_LIBDIR: ${PC_ZZIPLIB_LIBDIR}. ")
-  ELSEIF()
-    MESSAGE(WARNING "Using pkg_config, failed to find any version of Zziplib library!")
-  ENDIF()
-ENDIF()
-
-IF((APPLE) AND (PKG_CONFIG_FOUND))
   PKG_SEARCH_MODULE(PC_HUNSPELL hunspell libhunspell)
   IF(PC_HUNSPELL_FOUND)
     IF(PC_HUNSPELL_hunspell_FOUND)
@@ -348,3 +318,45 @@
   ENDIF()
 ENDIF()
 
+FIND_PACKAGE(Qt5Core REQUIRED)
+IF (Qt5Core_VERSION VERSION_LESS 5.6)
+  message(FATAL_ERROR "Mudlet requires Qt 5.6 or later")
+ENDIF()
+
+FIND_PACKAGE(Qt5Multimedia REQUIRED)
+FIND_PACKAGE(Qt5Network REQUIRED)
+FIND_PACKAGE(Qt5OpenGL REQUIRED)
+FIND_PACKAGE(Qt5UiTools REQUIRED)
+FIND_PACKAGE(Qt5Widgets REQUIRED)
+
+IF(WIN32)
+  SET(mudlet_RC_ICONS = icons/mudlet_main_512x512_6XS_icon.ico)
+  QT5_ADD_RESOURCES(RC_ICONS ${mudlet_RC_ICONS})
+ENDIF()
+
+IF(NOT(PC_ZIP_FOUND))
+  FIND_PACKAGE(ZIP REQUIRED)
+ENDIF()
+FIND_PACKAGE(OpenGL REQUIRED)
+FIND_PACKAGE(Lua51 REQUIRED)
+FIND_PACKAGE(ZLIB REQUIRED)
+FIND_PACKAGE(PCRE REQUIRED)
+FIND_PACKAGE(YAJL REQUIRED)
+
+# Fall back on original FIND_PACKAGE process on Apple if Package Config failed
+# Originally we did use that but it started to fail on Travis C.I. in June 2016
+# So we now try to use PackageConfig for MacOs platform
+IF(APPLE)
+  IF(NOT(PC_HUNSPELL_FOUND))
+    FIND_PACKAGE(HUNSPELL REQUIRED)
+  ENDIF()
+ELSE()
+  FIND_PACKAGE(HUNSPELL REQUIRED)
+ENDIF()
+
+FIND_PACKAGE(Boost 1.44 COMPONENTS graph)
+
+ADD_DEFINITIONS(-DAPP_VERSION="${APP_VERSION}" -DAPP_BUILD="${APP_BUILD}" -DAPP_TARGET="${APP_TARGET}")
+
+IF(UNIX)
+    SET(DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/share" CACHE STRING "The platform-specific directory in which read-only data is generally installed")

=== 3rdparty/communi/CMakeLists.txt ===
############################################################################
# Communi                                                                  #
#                                                                          #
#    Copyright (C) 2014-2017 by Ahmed Charles - acharles@outlook.com       #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

PROJECT(communi)

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5Network REQUIRED)

SET(SRCS
  src/core/irc.cpp
  src/core/irccommand.cpp
  src/core/ircconnection.cpp
  src/core/irccore.cpp
  src/core/ircfilter.cpp
  src/core/ircmessage.cpp
  src/core/ircmessage_p.cpp
  src/core/ircmessagecomposer.cpp
  src/core/ircmessagedecoder.cpp
  src/core/ircmessagedecoder_none.cpp
  src/core/ircnetwork.cpp
  src/core/ircprotocol.cpp
  src/3rdparty/mozilla/rdf_utils.c
)
SET(HDRS
  include/IrcCore/irccommand_p.h
  include/IrcCore/ircconnection_p.h
  include/IrcCore/ircdebug_p.h
  include/IrcCore/ircmessage_p.h
  include/IrcCore/ircmessagecomposer_p.h
  include/IrcCore/ircmessagedecoder_p.h
  include/IrcCore/ircnetwork_p.h
)
SET(MOC_HDRS
  include/IrcCore/irc.h
  include/IrcCore/irccommand.h
  include/IrcCore/ircconnection.h
  include/IrcCore/ircmessage.h
  include/IrcCore/ircnetwork.h
  include/IrcCore/ircprotocol.h
)
SET(PUB_HDRS
  ${MOC_HDRS}
  include/IrcCore/irccore.h
  include/IrcCore/ircfilter.h
  include/IrcCore/ircglobal.h
  include/IrcCore/Irc
  include/IrcCore/IrcCommand
  include/IrcCore/IrcCommandFilter
  include/IrcCore/IrcConnection
  include/IrcCore/IrcCore
  include/IrcCore/IrcGlobal
  include/IrcCore/IrcMessage
  include/IrcCore/IrcMessageFilter
  include/IrcCore/IrcNetwork
  include/IrcCore/IrcProtocol
)

QT5_GENERATE_MOC(include/IrcCore/irc.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irc.cpp)
QT5_GENERATE_MOC(include/IrcCore/irccommand.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irccommand.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircconnection.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircconnection.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircmessage.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessage.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircmessagecomposer_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessagecomposer_p.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircnetwork.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircnetwork.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircprotocol.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircprotocol.cpp)

SET_PROPERTY(SOURCE src/core/irc.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irc.cpp)
SET_PROPERTY(SOURCE src/core/irccommand.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irccommand.cpp)
SET_PROPERTY(SOURCE src/core/ircconnection.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircconnection.cpp)
SET_PROPERTY(SOURCE src/core/ircmessage.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessage.cpp)
SET_PROPERTY(SOURCE src/core/ircmessagecomposer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessagecomposer_p.cpp)
SET_PROPERTY(SOURCE src/core/ircnetwork.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircnetwork.cpp)
SET_PROPERTY(SOURCE src/core/ircprotocol.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircprotocol.cpp)

ADD_LIBRARY(communi STATIC ${SRCS} ${HDRS} ${PUB_HDRS})

TARGET_LINK_LIBRARIES(communi ${Qt5Core_LIBRARIES} ${Qt5Network_LIBRARIES})

TARGET_INCLUDE_DIRECTORIES(communi PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}/IrcCore
)
TARGET_INCLUDE_DIRECTORIES(communi PUBLIC
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Network_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcCore
)

=== 3rdparty/luazip/CMakeLists.txt ===
PROJECT(luazip LANGUAGES C)

FIND_PACKAGE(Lua51 REQUIRED)

# Break each step into a separate command so any status message is output straight away
# The include directory setup for Zip is unusual in that as well as e.g. /usr/include/zip.h
# we need the path to an interal header zipconf.g that it calls for using '<''>'s
# i.e. SYSTEM #include delimiters which are typically located at e.g. /usr/lib/libzip/include/zipconf.h
# and using pkg-config is the recommended way to get the details.
# Spotted recommendation to use pkg-config here https://github.com/Homebrew/homebrew/issues/13390
FIND_PACKAGE(PkgConfig)
IF(NOT(PKG_CONFIG_FOUND))
  MESSAGE(WARNING "Unable to use pkg_config - will possibly fail to find/use Zip library...")
ENDIF()

IF(PKG_CONFIG_FOUND)
  # Examining Homebrew (for MacOs) for libzzip:
  # https://bintray.com/homebrew/bottles/libzzip found that they use pkg-config
  # So use that to try and find what we want
  PKG_SEARCH_MODULE(PC_ZZIPLIB zziplib libzzip zzip)
  IF(PC_ZZIPLIB_FOUND)
    IF(PC_ZZIPLIB_zziplib_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"zziplib\" version: ${PC_ZZIPLIB_zziplib_VERSION} with:")
    ELSEIF(PC_ZZIPLIB_libzzip_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"libzzip\" version: ${PC_ZZIPLIB_libzzip_VERSION} with:")
    ELSEIF(PC_ZZIPLIB_zzip_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"zzip\" version: ${PC_ZZIPLIB_zzip_VERSION} with:")
    ELSE()
      MESSAGE(STATUS "Using pkg_config, found Zzip version: ${PC_ZZIPLIB_VERSION} with:")
    ENDIF()
    MESSAGE(STATUS "  include directory(ies), ZZIPLIB_INCLUDE_DIRS: ${PC_ZZIPLIB_INCLUDE_DIRS} .")
    MESSAGE(STATUS "  library(ies): ZZIPLIB_LIBRARY_DIRS: ${PC_ZZIPLIB_LIBRARY_DIRS}; ZZIPLIB_LIBDIR: ${PC_ZZIPLIB_LIBDIR}. ")
  ELSEIF()
    MESSAGE(WARNING "Using pkg_config, failed to find any version of Zziplib library!")
  ENDIF()
ENDIF()

IF(NOT(PC_ZZIPLIB_FOUND))
  FIND_PACKAGE(ZZIPLIB)
ENDIF()
IF(NOT((ZZIPLIB_FOUND) OR (PC_ZZIPLIB_FOUND) OR (PC_ZZIPLIB_zziplib_FOUND) OR (PC_ZZIPLIB_libzzip_FOUND) OR (PC_ZZIPLIB_zzip_FOUND)))
  MESSAGE(WARNING "Failed to find any trace of zziplib (or zzip or libzzip)\n- so will not be able to build the (internal version for Mac builds) of the lua zip module that Mudlet needs.")
ENDIF()

ADD_LIBRARY(luazip INTERFACE)

TARGET_LINK_LIBRARIES(luazip INTERFACE ${LUA_LIBRARIES})

IF(PC_ZZIPLIB_FOUND)
  TARGET_LINK_LIBRARIES(luazip INTERFACE ${PC_ZZIPLIB_LIBRARIES})
ELSE()
  TARGET_LINK_LIBRARIES(luazip INTERFACE ${ZZIPLIB_LIBRARIES})
ENDIF()

TARGET_INCLUDE_DIRECTORIES(luazip INTERFACE ${CMAKE_CURRENT_SOURCE_DIR} ${LUA_INCLUDE_DIR})

IF(PC_ZZIPLIB_FOUND)
  TARGET_INCLUDE_DIRECTORIES(luazip INTERFACE ${PC_ZZIPLIB_INCLUDE_DIRS})
ELSE()
  TARGET_INCLUDE_DIRECTORIES(luazip INTERFACE ${ZZIPLIB_INCLUDE_DIRS})
ENDIF()

=== debian/changelog ===
mudlet (1:3.2.0-1build1) artful; urgency=medium

  * No-change rebuild against latest hunspell

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 20 Jun 2017 05:07:50 -0400

mudlet (1:3.2.0-1) unstable; urgency=medium

  * New upstream release
  * Removed luaglobal patch, using the upstream path logic

 -- Craig Small <csmall@debian.org>  Thu, 08 Jun 2017 22:02:36 +1000

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,9 @@
 
 Package: mudlet
 Architecture: alpha amd64 arm64 hppa i386 ia64 m32r m68k mips mipsel powerpc ppc64 ppc64el s390 s390x sh3 sh3eb sparc sparc64 x32
-Depends: ${shlibs:Depends}, ${misc:Depends}, lua5.1-rex-pcre, lua5.1-sql-sqlite3
+Depends: ${shlibs:Depends}, ${misc:Depends},
+         lua5.1-rex-pcre, lua5.1-sql-sqlite3,
+         lua-filesystem, lua-zip
 Suggests: hunspell-en-us
 Description: Graphical MUD client with fast lua scripting support
  A completely redesigned MUD (Multi User Dungeon) client that is easy to
